<?php
/**
 * Clase Base DP para BasePlaEmpresaColaboradorPerDP
 *
 * @package    
 * @subpackage BasePlaEmpresaColaboradorPerDP
 * @author     Willy
 * @version    SVN:: BasePlaEmpresaColaboradorPerDP.class.php,v 1.1 2022-07-23 14:30:20 william.taype Exp $
 */
abstract class BasePlaEmpresaColaboradorPerDP extends PlaEmpresaColaboradorPerBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof PlaEmpresaColaboradorPerBN )
    {
      $o_PlaEmpresaColaboradorPerBN = $bSetDefault;
      if($o_PlaEmpresaColaboradorPerBN->getPeriodo()) : $this->setPeriodo($o_PlaEmpresaColaboradorPerBN->getPeriodo()); endif;
      if($o_PlaEmpresaColaboradorPerBN->getIdEmpresa()) : $this->setIdEmpresa($o_PlaEmpresaColaboradorPerBN->getIdEmpresa()); endif;
      if($o_PlaEmpresaColaboradorPerBN->getIdColaborador()) : $this->setIdColaborador($o_PlaEmpresaColaboradorPerBN->getIdColaborador()); endif;
      if($o_PlaEmpresaColaboradorPerBN->getFechaCreacion()) : $this->setFechaCreacion($o_PlaEmpresaColaboradorPerBN->getFechaCreacion()); endif;
      if($o_PlaEmpresaColaboradorPerBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_PlaEmpresaColaboradorPerBN->getUsuarioCreacion()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(Periodo),(MAX(Periodo)+1), 1) AS Maximo FROM pla_empresa_colaborador_per;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setPeriodo($row[0]);

      if($this->getPeriodo() && $this->getIdEmpresa() && $this->getIdColaborador()){
        $a_Fields = array();

        if($this->getPeriodo()) : $a_Fields['Periodo'] = ($this->getPeriodo()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO pla_empresa_colaborador_per (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getPeriodo() && $this->getIdEmpresa() && $this->getIdColaborador())
      {
        $a_Fields = array();

        if($this->getPeriodo()) : $a_Fields['Periodo'] = ($this->getPeriodo()); endif;
        if($this->getIdEmpresa()) : $a_Fields['IdEmpresa'] = ($this->getIdEmpresa()); endif;
        if($this->getIdColaborador()) : $a_Fields['IdColaborador'] = ($this->getIdColaborador()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE pla_empresa_colaborador_per SET ".$sStringField." WHERE 1 AND Periodo='".$this->getPeriodo()."' AND IdEmpresa='".$this->getIdEmpresa()."' AND IdColaborador='".$this->getIdColaborador()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getPeriodo() && $this->getIdEmpresa() && $this->getIdColaborador())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM pla_empresa_colaborador_per WHERE 1 AND Periodo='".$this->getPeriodo()."' AND IdEmpresa='".$this->getIdEmpresa()."' AND IdColaborador='".$this->getIdColaborador()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vPeriodo, $vIdEmpresa, $vIdColaborador)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT Periodo, IdEmpresa, IdColaborador, FechaCreacion, UsuarioCreacion FROM pla_empresa_colaborador_per WHERE 1 AND Periodo='".$vPeriodo."' AND IdEmpresa='".$vIdEmpresa."' AND IdColaborador='".$vIdColaborador."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_PlaEmpresaColaboradorPerDP = new PlaEmpresaColaboradorPerDP();
    $o_PlaEmpresaColaboradorPerDP->setPeriodo($o_propel->Periodo);
    $o_PlaEmpresaColaboradorPerDP->setIdEmpresa($o_propel->IdEmpresa);
    $o_PlaEmpresaColaboradorPerDP->setIdColaborador($o_propel->IdColaborador);
    $o_PlaEmpresaColaboradorPerDP->setFechaCreacion($o_propel->FechaCreacion);
    $o_PlaEmpresaColaboradorPerDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    return $o_PlaEmpresaColaboradorPerDP;
  }
}